/*******************************************************************************
  File: E2A.h
  Developed for Project: Amber, Fare Evaluator
  Proprietary & Confidential Unauthorized Disclosure strictly prohibited
  Copyright (c) 1999 Atraxis AG
  All Rights Reserved.

//$----------------------------------------------------------------------------|
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  An EBCDIC to/from ASCII converter.

//%****************************************************************************************/
#ifndef UTIL_E2A_H
#define UTIL_E2A_H

// Platform header
#include <platform.h>

// Standard C++ headers
#include <functional>

namespace Util {

//
// EBCDIC <-> ASCII conversion
//
struct EBCDIC2ASCII : std::unary_function<char, char> {
	static const unsigned char e2a[256];
	unsigned char operator()(unsigned char c) const {
		return e2a[c];
	}
};

struct ASCII2EBCDIC : std::unary_function<char, char> {
	static const unsigned char a2e[256];
	unsigned char operator()(unsigned char c) const {
		return a2e[c];
	}
};

} //> namespace Util

#endif
