/*******************************************************************************
  File: XdrStream_writer.hxx
  Copyright (c) 1999 Bleading Edge Software Technologies, Inc.

  This Software is distributed under the open source, free software model.
  Permission to use, modify, and distribute this Software, including
  incorporating it into proprietary software, is granted without fee, 
  provided this copyright notice appear in all copies of the code.
  You are under no obligation to distribute source code which is derived from
  or uses this Software. You may not do anything however, to prevent the 
  continued distribution of this Software under an open source distribution
  model. This includes, but is not limited to, such things as copyrighting
  or claiming authorship of the Software.
  This Software is distributed in the hope that it will be useful, but it is
  provide "as is", WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

//$-----------------------------------------------------------------------------
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  Implements the exported templates of oXDR_Stream.
  
//#----------------------------------------------------------------------------|
Notes:
  
//%****************************************************************************/
// My header
#include "XDRStream.h"

namespace Util {

template<typename T>
oXDR_Stream& 
oXDR_Stream::put_array(const T* a, ptrdiff_t l)
{
	sentry qx(*this);
	if (not qx) return *this;

	while (good() and l > 0) {
		*this << *a;
		++a; 
		--l;
	}
	return *this;
}


template<typename T>
oXDR_Stream& 
oXDR_Stream::vput_array(const T* a, ptrdiff_t l)
{
	*this << static_cast<long>(l);
	return put_array(a, l);
}


template<typename T>
oXDR_Stream&
put_optional(oXDR_Stream& oxs, const T* data)
{
	if (data) {
		oxs << 1 << *data;
	} else {
		oxs << 0;
	}
	return oxs;
}


} // namespace Util
